/* velocity bug , transparency slow, window place */
/****************************************************************/
/****          schprel.c by Mark Flider (2000)               ****/
/****           now with MacOS includes                      ****/
/****           descended from shnail                        ****/
/****    (C) 1994 Board of Trustees University of Illinois   ****/ 
/****    A Model Real-Time Interactive CAVE Application      ****/
/****    George Francis, Glenn Chappell, Chris Hartman       ****/
/****    e-mail  gfrancis@math.uiuc.edu                      ****/
/****    with Stuart Levy's opengl_stars.c                      */ 
/****************************************************************/

#pragma warning (disable:4305)  /* double-to-float  */
#pragma warning (disable:4101)	/* unreferenced local variable */
#pragma warning (disable:4056)	/* overflow in fp constant arithmetic */

#include <stdlib.h>
#include <stdio.h>
#include <sys/timeb.h>    /* for the speedometer */
#include <gl/glut.h>
#include <math.h>
#include <malloc.h>
#define M_PI 3.14159265
/* includes same as skel.c */
#ifdef __MWERKS__
 #include <math.h>
 #define M_PI 3.14159265
 #define fcos cos
 #define fsin sin
 #define mac_fabsf fabs
 #define farr macfar
 #define random rand
 #define fsqrt sqrt
#else
 #include <math.h>
 #include <sys/timeb.h>
#endif

#include <stdio.h>
#include <gl/glut.h>

#ifdef SOUND
/* #include <device.h> */
#include <string.h>
#include "vssClient.h"
#endif
#ifdef CAVE
#include <cave_ogl.h>
#include <cave.macros.h>
#endif 

/* Examples of useful geometric macros, use inliners in C++ */
#define  MAX(x,y)         (((x)<(y))?(y):(x))
#define  MIN(x,y)         (((x)<(y))?(x):(y))
#define  ABS(x)           fabs(x) 
#define  FOR(a,b,c)       for((a)=(b);(a)<(c);(a)++)
#define  DOT(p,q)         ((p)[0]*(q)[0]+(p)[1]*(q)[1]+(p)[2]*(q)[2])
#define  NRM(p)           sqrt(DOT((p),(p)))
#define  CLAMP(x,u,v) (x<u? u : (x>v ? v: x))

/* global variables ... add new ones on top of the stack */
char	which[20]; /* audio needs this */
int		delta; /* new variables for autotymer to change torus */
float	gap0=1.; /*very bad kludge ... for letting arguments reset default gap value */
int		audiohandle; /* for telling vss the name of the .aud file */
float	lux[3]={1.,2.,3.};             /*light source direction vector        */
float	lu[3];     /* this needs to be shared current light direction vector*/
float	mysiz,speed, torq, focal, farr; /*console navigation variables         */
int		win = 0;                         /* full screen, use 0 for demand sized */
unsigned int BUT,XX,YY,SHIF;     /* used in chaptrack gluttery           */ 
int		xt,yt;                       /* once was xt,yt,xm,ym for viewportery */
int		caveyes=0;                      /* rename? ----------> caveflag */
int		morph,msg,binoc;            /* pretty global */
/* note mode, alfa, beta, lima DO need to be shared to make autotymer right */ 

#define FLYMODE  (0)
#define TURNMODE (1) 
#define MOVING (0)
#define FROZEN (1)
#define GALILEAN (0)
#define RELATIVE (1)


int a,b,d,wVert;
float vex,vey,vez;

/*Shared memory variables as per Stuart Levy 1994 */  
struct share_var{ 
    float  s_vel;
    float s_flod[1001][3];
    float s_flodraw[1001][3];
    float s_ceid[1001][3];
    float s_ceidraw[1001][3];
    float s_beam[16][30][3];
    float s_beamdraw[16][30][3];
    float s_pillars[40][40][3]; 
    float s_pilldraw[40][40][3];
    float s_trib[16][5][3]; 
    float s_tribdraw[16][5][3];
    float s_trit[16][5][3];
    float s_tritdraw[16][5][3];
    int s_track;  /* 1 relativistic 0 galilean */
    float s_c;
    float s_tyme;

   int	 s_mode ;           /* because drawhoop uses it to change color */
   float s_alfa ;           /* because autotymer changes these display vars */
   float s_beta ;
   float s_lima ;
   float s_one ;
   float s_two ;
   float s_tri ;
   float s_th0 ;           
   float s_th1 ;       
   float s_ta0 ;      
   float s_ta1 ;     
   float s_gap ;  
   float s_siz ;         /*final scaling factor before projection      */  
   int   s_wnd;            /*wand or maus flag                           */
   int   s_gnd;            /*background color                            */
   float s_lu[3];         /* current light direction */ 
   int   s_mauspaw ;      /*binary for mouse button state                     */
   GLfloat s_aff[16],s_starmat[16]; /*affine matrices for object, stars*/
} *s_var; 

#define vel  (s_var->s_vel)
#define flod  (s_var->s_flod) 
#define flodraw (s_var->s_flodraw)
#define ceid (s_var->s_ceid)
#define ceidraw (s_var->s_ceidraw)
#define pillars (s_var->s_pillars)
#define pilldraw (s_var->s_pilldraw)
#define beam (s_var->s_beam)
#define beamdraw (s_var->s_beamdraw)
#define trib (s_var->s_trib)
#define   tribdraw (s_var->s_tribdraw)
#define trit (s_var->s_trit)
#define   tritdraw (s_var->s_tritdraw)
#define track (s_var->s_track)
#define c (s_var->s_c)
#define    tyme (s_var->s_tyme)

#define mode    (s_var->s_mode)
#define alfa    (s_var->s_alfa)
#define beta    (s_var->s_beta)
#define lima    (s_var->s_lima)
#define one     (s_var->s_one)
#define two     (s_var->s_two)
#define tri     (s_var->s_tri)
#define th0     (s_var->s_th0)
#define th1     (s_var->s_th1)
#define ta0     (s_var->s_ta0)
#define ta1     (s_var->s_ta1)
#define gap     (s_var->s_gap)
#define siz     (s_var->s_siz)
#define wnd     (s_var->s_wnd)
#define gnd     (s_var->s_gnd)  /* use only if printframe function is present */
#define lu      (s_var->s_lu )  /* else the right wall isn't specularized */
#define aff     (s_var->s_aff)  
#define starmat (s_var->s_starmat)
#define mauspaw (s_var->s_mauspaw)

/* these are used only in console mode      */
float nose;   /* to eye distance in console */

void getmem(void){
  if(caveyes)
#ifdef CAVE
     s_var = CAVEMalloc(sizeof(struct share_var))
#endif
     ;
   else
     s_var = malloc(sizeof(struct share_var));
  if(s_var==NULL)
    {fprintf(stderr,"No room to share! %x \n",s_var); exit(1);}
}

void char2wall(GLfloat x,GLfloat y, GLfloat z, char buf[]){
     char *p; glRasterPos3f(x,y,z);
     for(p = buf;*p;p++) glutBitmapCharacter(GLUT_BITMAP_9_BY_15,*p);
}


void autotymer(int);  /* to allow deFault to call the autotymer later */
void caveframe(void);
void deFault(void){
  int ii; float tmp;
  msg=1; binoc=0; nose=.06; mauspaw = 0; wnd = 1; siz = 1.; 
  mode=FROZEN; /* same a TURNMODE in Galilean track */  
  speed=1; /* max speed; between 0 and 1 */
  vel = .25;  /* how fast we're moving      */
  track = RELATIVE; /* relativistic */
  c = .8;   	/* speed of light */
  torq=.005; focal = 2.; farr =500.; mysiz=.01; morph=0; 
  for(ii=0;ii<16;ii++)  starmat[ii]=aff[ii] = (ii/4==ii%4) ? 1 : 0;   
  tmp=NRM(lux);  for(ii=0;ii<3;ii++)lux[ii]/=tmp;
  if(caveyes){aff[12]=0; aff[13]= 0; aff[14]= 0 ; } /*5ft beyond front wall*/ 
       else{aff[12]=0; aff[13]= 0; aff[14]= -4.2; } /*inside the console */ 

   wVert=0;
   for (vez=-25;vez<=25;vez++)  /* initialize floor matrix */
   for (vex=-25;vex<=25;vex++)
   if ((int)vex % 5 == 0 || (int)vez % 5 == 0)
        {
        flod[wVert][0] = vex;
        flod[wVert][1] = -5;
	flod[wVert][2] = vez;
        wVert++;
        }
   for (a=0;a<1001;a++)
   for (b=0;b<3;b++)
	flodraw[a][b] = flod[a][b];

   for (a=0;a<1001;a++)		/* init ceiling matrix */
   {
      ceid[a][0] = ceidraw[a][0] = flodraw[a][0];
      ceid[a][1] = ceidraw[a][1] = 4;
      ceid[a][2] = ceidraw[a][2] = flodraw[a][2];
   }

   for (a=0;a<11;a++) {     /* init pillars matrix */
      wVert=0;
      for (vey=0;vey<10;vey++)
      for (vex=-.25;vex<=.25;vex+=.5)
      for (vez=-.25;vez<=.25;vez+=.5)
      {
         pillars[a][wVert][0] = vex-25;
         pillars[a][wVert][1] = vey-5;
         pillars[a][wVert][2] = vez-25+a*5;
         wVert++;
      }
   }
   for (a=0;a<11;a++)
   for (b=0;b<40;b++)
   for (d=0;d<3;d++)
      pilldraw[a][b][d] = pillars[a][b][d];


   vey = 0;		/* init trit, trib matrices */
   a=0;
   for (b=-2;b<=2;b++)
   for (d=-2;d<=2;d++)
   {
      if ( fabs(b)==2 || fabs(d)==2 )
      {
         trib[a][0][0] = b;
         trib[a][0][1] = -4.9;
         trib[a][0][2] = d;
         wVert=1;
         for (vex=-.09;vex<=.09;vex+=.18)
         for (vez=-.09;vez<=.09;vez+=.18)
         {
            trib[a][wVert][0] = vex+b;
            trib[a][wVert][1] = -5;
            trib[a][wVert][2] = vez+d;
            wVert++;
         }
         a++;
      }
   }

   for (a=0;a<16;a++)
   for (wVert=0;wVert<5;wVert++)
   {
      trit[a][wVert][0] = trib[a][wVert][0];
      trit[a][wVert][1] = -1.0-trib[a][wVert][1];
      trit[a][wVert][2] = trib[a][wVert][2];
   }
   for (a=0;a<16;a++)
   for (wVert=0;wVert<5;wVert++)
   for (b=0;b<3;b++)
   {
      tribdraw[a][wVert][b] = trib[a][wVert][b];
      tritdraw[a][wVert][b] = trit[a][wVert][b];
   }

   for (a=0;a<16;a++)		/* init beam matrix */
   {
   wVert = 0;
   for (vey = tribdraw[a][0][1];vey<=tritdraw[a][0][1];vey+=(tritdraw[a][0][1]-tribdraw[a][0][1])/29)
      {
         beamdraw[a][wVert][0] = beam[a][wVert][0] = tribdraw[a][0][0];
         beamdraw[a][wVert][1] = beam[a][wVert][1] = vey;
         beamdraw[a][wVert][2] = beam[a][wVert][2] = tribdraw[a][0][2];
         wVert++;
      }
   }

   autotymer(1); /* reset autotymer to start at the beginning */
}


void drawfloor(void){

float color;
#ifndef __MWERKS__
        glEnable(GL_LINE_SMOOTH);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
        glHint(GL_LINE_SMOOTH_HINT,GL_DONT_CARE);

	color = 1.;
#else
	color = .5;
#endif

   for (d=0;d<950;d+=95)
   for (a=d;a<d+50;a+=5)
   {
      glBegin(GL_TRIANGLE_STRIP);
      glColor4f(0,color,color,.2);
      wVert=a+1;
         glVertex3f(flodraw[a][0],flodraw[a][1],flodraw[a][2]);
      for (b=a+51-(a-d)/5*4;b<a+85-(a-d)/5*4;b+=11)
      {
         glVertex3f(flodraw[wVert][0],flodraw[wVert][1],flodraw[wVert][2]);
         glVertex3f(flodraw[b][0],flodraw[b][1],flodraw[b][2]);
         wVert++;
      }
      glVertex3f(flodraw[wVert][0],flodraw[wVert][1],flodraw[wVert][2]);
      glVertex3f(flodraw[a+95][0],flodraw[a+95][1],flodraw[a+95][2]);
      glEnd();

      glBegin(GL_TRIANGLE_STRIP);
      glColor4f(0,color,color,.2);
      wVert=a+95;
         glVertex3f(flodraw[a+5][0],flodraw[a+5][1],flodraw[a+5][2]);
      for (b=a+56-(a+5-d)/5*4;b<a+90-(a+5-d)/5*4;b+=11)
      {
         glVertex3f(flodraw[wVert][0],flodraw[wVert][1],flodraw[wVert][2]);
         glVertex3f(flodraw[b][0],flodraw[b][1],flodraw[b][2]);
         wVert++;
      }
      glVertex3f(flodraw[wVert][0],flodraw[wVert][1],flodraw[wVert][2]);
      glVertex3f(flodraw[a+100][0],flodraw[a+100][1],flodraw[a+100][2]);
      glEnd();
   }

   for (a=0;a<1001;a+=95)
   {
      glBegin(GL_LINE_STRIP);
      glColor4f(0,color,color,.75);
      for (wVert=a;wVert<51+a;wVert++)
         glVertex3f(flodraw[wVert][0],flodraw[wVert][1]+.01,flodraw[wVert][2]);
      glEnd();
   }
   for (a=0;a<51;a+=5)
   {
      glBegin(GL_LINE_STRIP);
      glColor4f(0,color,color,.75);
         glVertex3f(flodraw[a][0],flodraw[a][1]+.01,flodraw[a][2]);
      for (b=51+a/5;b<1001;b+=95)
      {
      for (wVert=b;wVert<11*4+b;wVert+=11)
         glVertex3f(flodraw[wVert][0],flodraw[wVert][1]+.01,flodraw[wVert][2]);
      glVertex3f(flodraw[wVert+a/5*4][0],flodraw[wVert+a/5*4][1]+.01,flodraw[wVert+a/5*4][2]);
      }
      glEnd();
   }
}

void drawceiling(void){

float color;
#ifndef __MWERKS__

        glEnable(GL_LINE_SMOOTH);
        glEnable(GL_BLEND);
        glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
        glHint(GL_LINE_SMOOTH_HINT,GL_DONT_CARE);

        color = 1.;
#else
        color = .5;
#endif

   for (d=0;d<950;d+=95)
   for (a=d;a<d+50;a+=5)
   {
      glBegin(GL_TRIANGLE_STRIP);
      glColor4f(0,color/2,color,.1);
      wVert=a+1;
         glVertex3f(ceidraw[a][0],ceidraw[a][1],ceidraw[a][2]);
      for (b=a+51-(a-d)/5*4;b<a+85-(a-d)/5*4;b+=11)
      {
         glVertex3f(ceidraw[wVert][0],ceidraw[wVert][1],ceidraw[wVert][2]);
         glVertex3f(ceidraw[b][0],ceidraw[b][1],ceidraw[b][2]);
         wVert++;
      }
      glVertex3f(ceidraw[wVert][0],ceidraw[wVert][1],ceidraw[wVert][2]);
      glVertex3f(ceidraw[a+95][0],ceidraw[a+95][1],ceidraw[a+95][2]);
      glEnd();

      glBegin(GL_TRIANGLE_STRIP);
      glColor4f(0,color/2,color,.1);
      wVert=a+95;
         glVertex3f(ceidraw[a+5][0],ceidraw[a+5][1],ceidraw[a+5][2]);
      for (b=a+56-(a+5-d)/5*4;b<a+90-(a+5-d)/5*4;b+=11)
      {
         glVertex3f(ceidraw[wVert][0],ceidraw[wVert][1],ceidraw[wVert][2]);
         glVertex3f(ceidraw[b][0],ceidraw[b][1],ceidraw[b][2]);
         wVert++;
      }
      glVertex3f(ceidraw[wVert][0],ceidraw[wVert][1],ceidraw[wVert][2]);
      glVertex3f(ceidraw[a+100][0],ceidraw[a+100][1],ceidraw[a+100][2]);
      glEnd();
   }

   for (a=0;a<1001;a+=95)
   {
      glBegin(GL_LINE_STRIP);
      glColor4f(0,color/2,color,.75);
      for (wVert=a;wVert<51+a;wVert++)
         glVertex3f(ceidraw[wVert][0],ceidraw[wVert][1]-.01,ceidraw[wVert][2]);
      glEnd();
   }
   for (a=0;a<51;a+=5)
   {
      glBegin(GL_LINE_STRIP);
      glColor4f(0,color/2,color,.75);
         glVertex3f(ceidraw[a][0],ceidraw[a][1]-.01,ceidraw[a][2]);
      for (b=51+a/5;b<1001;b+=95)
      {
      for (wVert=b;wVert<11*4+b;wVert+=11)
         glVertex3f(ceidraw[wVert][0],ceidraw[wVert][1]-.01,ceidraw[wVert][2]);
      glVertex3f(ceidraw[wVert+a/5*4][0],ceidraw[wVert+a/5*4][1]-.01,ceidraw[wVert+a/5*4][2]);
      }
      glEnd();
   }
}


void drawpillars(void) {

for (a=0;a<11;a++) {
   glColor4f(.75,.25,0,1);
   glBegin(GL_TRIANGLE_STRIP);
      for (wVert=0;wVert<40;wVert+=4) {
         glVertex3f(pilldraw[a][wVert][0],pilldraw[a][wVert][1],pilldraw[a][wVert][2]);
	 glVertex3f(pilldraw[a][wVert+1][0],pilldraw[a][wVert+1][1],pilldraw[a][wVert+1][2]);
      }
   glEnd();
   glBegin(GL_TRIANGLE_STRIP);
      for (wVert=0;wVert<40;wVert+=4) {
         glVertex3f(pilldraw[a][wVert][0],pilldraw[a][wVert][1],pilldraw[a][wVert][2]);
         glVertex3f(pilldraw[a][wVert+2][0],pilldraw[a][wVert+2][1],pilldraw[a][wVert+2][2]);
      }
   glEnd();
   glBegin(GL_TRIANGLE_STRIP);
      for (wVert=3;wVert<40;wVert+=4) {
         glVertex3f(pilldraw[a][wVert][0],pilldraw[a][wVert][1],pilldraw[a][wVert][2]);
         glVertex3f(pilldraw[a][wVert-1][0],pilldraw[a][wVert-1][1],pilldraw[a][wVert-1][2]);
      }
   glEnd();
   glBegin(GL_TRIANGLE_STRIP);
      for (wVert=3;wVert<40;wVert+=4) {
         glVertex3f(pilldraw[a][wVert][0],pilldraw[a][wVert][1],pilldraw[a][wVert][2]);
         glVertex3f(pilldraw[a][wVert-2][0],pilldraw[a][wVert-2][1],pilldraw[a][wVert-2][2]);
      }
   glEnd();

   glColor4f(1,1,1,1);
   for (b=0;b<4;b++) {
      glBegin(GL_LINE_STRIP);
         for (wVert=b;wVert<40;wVert+=4)
            glVertex3f(pilldraw[a][wVert][0],pilldraw[a][wVert][1],pilldraw[a][wVert][2]);
      glEnd();
   }
}
}



void drawtris(void) {

for (a=0;a<16;a++)
{
   glColor4f(.5,1,.2,1);
   glBegin(GL_TRIANGLE_FAN);
      glVertex3f(tribdraw[a][0][0],tribdraw[a][0][1],tribdraw[a][0][2]);
      glVertex3f(tribdraw[a][1][0],tribdraw[a][1][1],tribdraw[a][1][2]);
      glVertex3f(tribdraw[a][2][0],tribdraw[a][2][1],tribdraw[a][2][2]);
      glVertex3f(tribdraw[a][4][0],tribdraw[a][4][1],tribdraw[a][4][2]);
      glVertex3f(tribdraw[a][3][0],tribdraw[a][3][1],tribdraw[a][3][2]);
      glVertex3f(tribdraw[a][1][0],tribdraw[a][1][1],tribdraw[a][1][2]);
   glEnd();

   glColor4f(.5,.2,1,1);
   glBegin(GL_TRIANGLE_FAN);
      glVertex3f(tritdraw[a][0][0],tritdraw[a][0][1],tritdraw[a][0][2]);
      glVertex3f(tritdraw[a][1][0],tritdraw[a][1][1],tritdraw[a][1][2]);
      glVertex3f(tritdraw[a][2][0],tritdraw[a][2][1],tritdraw[a][2][2]);
      glVertex3f(tritdraw[a][4][0],tritdraw[a][4][1],tritdraw[a][4][2]);
      glVertex3f(tritdraw[a][3][0],tritdraw[a][3][1],tritdraw[a][3][2]);
      glVertex3f(tritdraw[a][1][0],tritdraw[a][1][1],tritdraw[a][1][2]);
   glEnd();

   glColor4f(1,1,1,1);
   glBegin(GL_LINE_STRIP);
      glVertex3f(tribdraw[a][1][0],tribdraw[a][1][1],tribdraw[a][1][2]);
      glVertex3f(tribdraw[a][2][0],tribdraw[a][2][1],tribdraw[a][2][2]);
      glVertex3f(tribdraw[a][0][0],tribdraw[a][0][1],tribdraw[a][0][2]);
      glVertex3f(tribdraw[a][3][0],tribdraw[a][3][1],tribdraw[a][3][2]);
      glVertex3f(tribdraw[a][4][0],tribdraw[a][4][1],tribdraw[a][4][2]);
   glEnd();
   glBegin(GL_LINE_STRIP);
      glVertex3f(tribdraw[a][1][0],tribdraw[a][1][1],tribdraw[a][1][2]);
      glVertex3f(tribdraw[a][3][0],tribdraw[a][3][1],tribdraw[a][3][2]);
      glVertex3f(tribdraw[a][0][0],tribdraw[a][0][1],tribdraw[a][0][2]);
      glVertex3f(tribdraw[a][2][0],tribdraw[a][2][1],tribdraw[a][2][2]);
      glVertex3f(tribdraw[a][4][0],tribdraw[a][4][1],tribdraw[a][4][2]);
   glEnd();

   glBegin(GL_LINE_STRIP);
      glVertex3f(tritdraw[a][1][0],tribdraw[a][1][1],tribdraw[a][1][2]);
      glVertex3f(tritdraw[a][2][0],tribdraw[a][2][1],tribdraw[a][2][2]);
      glVertex3f(tritdraw[a][0][0],tribdraw[a][0][1],tribdraw[a][0][2]);
      glVertex3f(tritdraw[a][3][0],tribdraw[a][3][1],tribdraw[a][3][2]);
      glVertex3f(tritdraw[a][4][0],tribdraw[a][4][1],tribdraw[a][4][2]);
   glEnd();
   glBegin(GL_LINE_STRIP);
      glVertex3f(tritdraw[a][1][0],tritdraw[a][1][1],tritdraw[a][1][2]);
      glVertex3f(tritdraw[a][3][0],tritdraw[a][3][1],tritdraw[a][3][2]);
      glVertex3f(tritdraw[a][0][0],tritdraw[a][0][1],tritdraw[a][0][2]);
      glVertex3f(tritdraw[a][2][0],tritdraw[a][2][1],tritdraw[a][2][2]);
      glVertex3f(tritdraw[a][4][0],tritdraw[a][4][1],tritdraw[a][4][2]);
   glEnd();

}
}


void drawbeams(void){

   glColor4f(.95,.95,1,1);
   glLineWidth(5);
for (a=0;a<16;a++)
   {
   glBegin(GL_LINE_STRIP);
   for (b=0;b<30;b++)
      glVertex3f(beamdraw[a][b][0],beamdraw[a][b][1],beamdraw[a][b][2]);
   glEnd();
   }
   glLineWidth(1);
}


drawall(){
   drawpillars(); drawtris(); drawbeams(); drawfloor(); drawceiling(); 
}

#include "opengl_stars.c"
#if 0
void drawstars(void){
int i;
static float star[1000][3];
static int virgin=1;
if(virgin){
  int ii,jj;
  float fact;
  virgin=0;
  for(ii=0;ii<1000;ii++)
     {
     for(jj=0;jj<3;jj++) star[ii][jj] =   rand()/(float)0x40000000-1.;
     if(caveyes){
           fact = 90./NRM(star[ii]);
           for(jj=0;jj<3;jj++) star[ii][jj] *= fact;
           }   
     }
  }
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMultMatrixf(starmat);
  glColor3f(1.0,1.0,0.0);    
  glBegin(GL_POINTS);
    for(i=0;i<1000;i++) glVertex3fv(star[i]);
  glEnd();
  glPopMatrix();
  glClear(GL_DEPTH_BUFFER_BIT);
}
#endif

void audioprep(void){
#ifdef SOUND
   if (!FBgnSoundServer())
      fprintf(stderr,"UDP connection to sound server failed\n");
   else if ((audiohandle = AUDinit("noosh.aud")) == -1)
      fprintf(stderr,"Couldn't open noosh.aud\n");
#endif
}

void dohoot(void) {strcpy(which,"hoot");}
void dotrump(void){strcpy(which,"trump");}
void doflute(void){strcpy(which,"flute");}
void dodrum(void) {strcpy(which,"drum");}

void audiofunc(void){
#ifdef SOUND 
#define LIRP(X,A,B,x,a,b)  (X = A + (x-a)*(B-A)/(b-a))
  static float freq=440., ampl=1., indx=20., cmra=2.; 
  static float data[4];
  static omode =0; static ofocal = 0;
  static beep =0;  /* the sound server */

  if(omode > mode){dohoot(); beep = 1;}
  if(omode < mode){dodrum(); beep = 1;}

  LIRP(freq, 440, 1760, th0,  10, 170); /* frequeny mimics th1 */ 
  LIRP(indx, 10, 1,  focal, .03, 2.0); /* index  mimics focal */ 
  if(ofocal != focal){dodrum(); beep = 1;}    /* there is an fp bug here */

if(beep){data[0] = freq;  /* pitch in Herz      */ 
          data[1] = ampl;  /* the sum of all amplitudes must be < 1.0 */ 
          data[2] = indx;    
          data[3] = cmra;
          AUDupdate(audiohandle, which, 4, data);  /* send message  to vss */ 
          beep = 0; 
}
  omode = mode;  ofocal = focal; 
#endif
}

void audioclean(void){
#ifdef SOUND
   AUDterminate(audiohandle);
   EndSoundServer();
#endif
}

void arguments(int argc,char **argv){
#if 0
#ifndef __MWERKS__
  extern char *optarg;
  extern int optind; 
  int chi;   
  /* w: needs ONE number after -w, c<nothing> means NO number follows */
  while ((chi = getopt(argc,argv,"w:cd:g:")) != -1) 
  switch(chi)  {case 'c': caveyes=1; break;  
                case 'w': win=atoi(optarg); break; 
                case 'g': gap0=atof(optarg); break;
                }
  if (optind!=argc) fprintf(stderr,"%s: Incorrect usage\n",argv[0]);
#endif
#endif
  win=0;
}

void dataprep(void){
   audioprep();
   deFault();
   initstars();
}

void autotymer(int reset){
   #define  TYME(cnt,max,act) {static cnt; if(first)cnt=max; else\
                               if(cnt?cnt--:0){ act ; goto Break;}}
   static first = 1;  /* the first time autymer is called */
   if(reset)first=1;  /* or if it is reset to start over  */
  TYME( snl2mob,72, ta0++; ta1--) /*shrink snail to moebius*/
  TYME( mob2snl,72, ta0--; ta1++) /*grow moebius to snail*/
  first = 0;
  Break: ;                         /*yes Virginia, C has gotos */
}/*end autotymer*/

void flitrack (int but,int xx,int yy,int shif); /*prototype*/

/*Beware of competing keys in CAVEsimulation and wnd==1   */
/* you may want to remap these keys to avoid the conflict */

void keyboard(unsigned char key, int x, int y){
#define  IF(K)            if(key==K)
#define  PRESS(K,A,b)     IF(K){b;}IF((K-32)){A;}  
/*was backwards in previous versions */
#define  TOGGLE(K,flg)    IF(K){(flg) = 1-(flg); }
#define  CYCLE(K,f,m)     PRESS((K), (f)=(((f)+(m)-1)%(m)),(f)=(++(f)%(m)))
#define  SLIDI(K,f,m,M)   PRESS(K,(--f<m?m:f), (++f>M?M:f))
#define  SLIDF(K,f,m,M,d) PRESS(K,((f -= d)<m?m:f), ((f += d)>M?M:f))
/* Only ASCII characters can be processes by this GLUT callback function */ 
   TOGGLE('b',binoc);                            /* cross-eyed STEREO   */
   TOGGLE('w',msg);                              /* writing on/off      */
   TOGGLE('h',morph);                            /* autotymer on/off    */
   PRESS('n', nose -= .001 , nose += .001 );     /* for binoculars      */
   CYCLE(' ', mode,TURNMODE+1);                  /* fly/turn modes      */
   PRESS('i', mysiz /= 1.1, mysiz *= 1.1)        /* rescale the world   */
   PRESS('o', focal *= 1.1 , focal /= 1.1)       /* telephoto           */
   PRESS('p', farr *= 1.01 , farr   /= 1.01)       /* rear clipping plane */
   PRESS('v',vel=MIN(vel*1.1,c*.999),vel=MAX(vel/1.1,0));  /* velocity */
/* gkf guard v against changes in c better */
   PRESS('c', c=MAX(c*1.1,.0001), c= MAX(c/1.1,vel))
/*
   IF('w') { c = MAX(c*1.1,.0001); } else IF('s') {c = MAX(c/1.1,.0001);}
*/
   TOGGLE('t',track);
   
   PRESS('s',speed /= 1.02, speed *= 1.02);        /* flying speed       */
   PRESS('q',torq /= 1.02, torq *= 1.02);        /* turning speed       */
   PRESS('g',gap /= .99, gap *= .99);            /* gap parameter       */
   PRESS('z', deFault(), deFault());             /* zap changes         */
   IF(27) {audioclean(); exit(0); }              /* ESC exit            */
}

void special_keybo(int key, int x, int y){
/*non-ASCII keypresses go here, if you're lucky enough to know their names */
 fprintf(stderr," non-ASCII character was pressed.\n");
 fprintf(stderr," use special_keybo() to process it\n");
}
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */
#ifdef CAVE
/* %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% */

void cavekeybo(void){
#define  CAVEIF(K)         if(CAVEgetbutton(K))
#define  CAVEPRESS(K,A,b)  CAVEIF(K){if(CAVEgetbutton(CAVE_LEFTSHIFTKEY)||\
                           CAVEgetbutton(CAVE_RIGHTSHIFTKEY)){b;}else{A;}}
#define  CAVETOGGLE(K,flg) CAVEIF(K){(flg) = 1-(flg); }
#define  CAVECYCLE(K,f,m)  CAVEPRESS((K),(f)=(((f)+(m)-1)%(m)),(f)=(++(f)%(m)) )
#define  CAVESLIDI(K,f,m,M)  CAVEPRESS(K,(--f<m?m:f), (++f>M?M:f))
#define  CAVESLIDF(K,f,m,M,d) CAVEPRESS(K,((f -= d)<m?m:f), ((f += d)>M?M:f))
  CAVEPRESS(CAVE_PKEY, farr *= 1.01,   farr   /= 1.01) /* rear clipping plane*/
  CAVETOGGLE(CAVE_QKEY, track); /*track*/
  CAVEPRESS(CAVE_RKEY, torq /= 1.02,  torq *= 1.02); /* turning speed      */
  CAVETOGGLE(CAVE_YKEY,wnd);                         /* mauspaw vs wandpaw */
/* not yet implemented */ 
   CAVEPRESS(CAVE_ZKEY, deFault(), deFault());        /* zap changes       */
}

void graffiti(void){             /* used to be called speedo  */
  char buf[256];                 /*messages written into here */ 
#define  LABEL3(x,y,z,W,u){sprintf(buf,(W),(u));char2wall(x,y,z,buf);}
  static float last=0.,fps;      /*for measuring time         */ 
  if(!CAVEMasterDisplay()) return;  /* USE CAVEMasterWall in papeBeta */
  if(floor(2.*(*CAVETime))>floor(2.*last)){  /* rationalize this */ 
     last=*CAVETime;
     fps=*CAVEFramesPerSecond;
     }
  if(track==GALILEAN) /*Galilean*/ 
      {
        glColor3f(1.,1.,1.);
        LABEL3(-3.8,1.,-5.0,\
        " JUST LIKE IN SKEL .... GO RELATIVISTIC=(L)+(R)%s","");
        } 
   if(track==RELATIVE){
        glColor3f(1.,1.,0.);
        LABEL3(-3.8,1.0,-5.0, " VELOCITY=(extend arm)   LIGHT SPEED=(L)/(R)   ECSTASY=(M)  RESET = hold(M)click(R+L) %s",""); 
     }
     LABEL3(-4.8,8.0,-5.0, "SchpRel  \
by Mark Flider, (C) 2000 UIUC %s","");
       LABEL3(-4.8,1.0,-5.4,"%5.1f fps",fps);
       LABEL3(-4.8,1.5,-5.2,"c = %1.4f",c);
       LABEL3(-4.8,2.0,-5.0,"v = %1.4f",vel);
       LABEL3(-4.8,2.5,-5.0,"percent %1.4f",vel/c);
}

void flicavetrack(void){
  float azi,ele,rol,hx,hy,hz,wx,wy,wz;
  static float ohx,ohy,ohz;   /*old head position */
  static float owx,owy,owz;   /*old wand position */
  static int opaw = 0,paw, joy = 0, friz;

  if(!CAVEMasterDisplay()) return;  /* doit once per frame */
  paw = wnd ? (CAVEBUTTON1*2+CAVEBUTTON2)*2+CAVEBUTTON3 : mauspaw;

  if(opaw!=2 && paw==2){
    track = GALILEAN ; /* Galilean */
    mode = FLYMODE;
    caveframe();	/* go do normal cavetrack() */
    return;		/* and don't do the rest of our flicavetrack */
  }

#if 0
  if(mode==FROZEN){   /* hold middle button and click right to shrink */
     /* if (opaw == 2 && paw == 3)siz /= 1.5;     /*shrink object */
     /* if (opaw == 2 && paw == 6)siz *= 1.5;     /* grow   object */
     if(opaw==1 && paw == 5) vel = (vel+1.02)/1.02;  /* hold right and  */
     if(opaw==1 && paw == 3) vel = (vel-1.02)/1.02;  /* +left -mid (for v)  */
  /* the above is nonsense, but the below interferes with lightspeed */
     if(opaw==1 && paw == 5) vel = MIN(c*.99995,vel*1.02); /* hold right and  */
     if(opaw==1 && paw == 3) vel = vel/1.02;  /* +left -mid (for v)  */
     }
#endif

     if (paw == 4) c = c*1.005; 
     if (paw == 1)  c = MAX(c/1.005,vel/.99995);
  if(opaw==2 && paw == 7)
     { /* restart, the most useful feature */
       deFault(); ohx=ohy=ohz=0; owx=owy=owz=0;
       /* no sweat, deFault starts in flitrack */
     }

      CAVEGetWandOrientation(azi,ele,rol);
      CAVEGetHead(hx,hy,hz);  /*position*/
      CAVEGetWand(wx,wy,wz);  /*position*/

    if( MAX(ABS(hx-wx),ABS(hz-wz)) > 1 )mode=MOVING;
    if( MAX(ABS(hx-wx),ABS(hz-wz)) < 1 )mode=FROZEN;
 
    flitrack(0,(int)(azi*-5),(int)(ele*-5),0); /* ele doesn't for now */

   opaw=paw; ohx=hx; ohy=hy; ohz=hz;
             owx=wx; owy=wy; owz=wz;
   if(morph) autotymer(0);  /* advance autotymer */
   audiofunc();
}


void cavetrack(void){
  float azi,ele,rol,hx,hy,hz,wx,wy,wz;
  static float ohx,ohy,ohz;   /*old head position */
  static float owx,owy,owz;   /*old wand position */
  static int opaw = 0,paw, joy = 0, friz;

  if(!CAVEMasterDisplay()) return;  /* doit once per frame */
  paw = wnd ? (CAVEBUTTON1*2+CAVEBUTTON2)*2+CAVEBUTTON3 : mauspaw;
  if(paw) joy = 1; /* activate joystick by clicking any button*/
  if(opaw!=2 && paw==2) mode = (mode+1)%(TURNMODE+1); /* click modes */
#if 0
  if(mode==TURNMODE){   /* hold middle button and click right to shrink */
     if (opaw == 2 && paw == 3)siz /= 1.5;     /*shrink object */
     if (opaw == 2 && paw == 6)siz *= 1.5;     /* grow   object */
     if (opaw != 1 && paw == 1)friz = 1-friz;  /* parking option */
     if(opaw==1 && paw == 5)gap *= 1.2;  /* hold right and  */
     if(opaw==1 && paw == 3)gap /= 1.2;  /* +left -mid    */
     } 
#endif /* until the frozen wand bug is fixed */
   if (opaw != 5 && paw == 5)
     {
      track = RELATIVE; /* relativistic */
      mode = FROZEN; 
      deFault();
      caveframe();	/* go do flicavetrack() */
      return;		/* and don't do remainder of cavetrack() */
     }

  if (opaw != 4 && paw == 4)morph = 1-morph;/* shape changer */

  if(opaw==2 && paw == 7){ /* restart, the most useful feature */
     deFault(); ohx=ohy=ohz=0; owx=owy=owz=0;
     } 
  if(wnd){ 
      CAVEGetWandOrientation(azi,ele,rol);
      CAVEGetHead(hx,hy,hz);  /*position*/
      CAVEGetWand(wx,wy,wz);  /*position*/ 
      }
   else{  /* fix this for CAVE mouse flying */ 
      azi = .5*512; ele = .5*-512;
      } 
   glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();

   glTranslatef(ohx-hx,ohy-hy,ohz-hz); 
 if(mode==TURNMODE) glTranslatef(aff[12],aff[13],aff[14]);
   if(!friz){  /* if not parked */
      glRotatef(rol*(mode?torq:-torq),0.,0.,1.); 
      glRotatef(ele*-torq, 1.,0.,0.); 
      glRotatef(azi*-torq,0.,1.,0.);
      }
   if(joy&&((fabs(CAVE_JOYSTICK_Y)>.02)||(fabs(CAVE_JOYSTICK_X)>.02)))
       glTranslatef(CAVE_JOYSTICK_X*speed,0.,CAVE_JOYSTICK_Y*speed);
 
 if(opaw==2 && paw==2)glTranslatef(wx-owx, wy-owy, wz-owz); /*wand tractor */

 if(mode == TURNMODE) glTranslatef(-aff[12],-aff[13],-aff[14]);
   glMultMatrixf(aff); 
   glGetFloatv(GL_MODELVIEW_MATRIX,aff);

  {int ii,jj; for(ii=0;ii<3;ii++){ lu[ii]=0; /* calculite */
   for(jj=0;jj<3;jj++) lu[ii] += aff[ii*4+jj]*lux[jj];} }

   if(mode==FLYMODE && !friz) /*make the star matrix rotate*/
      {
      glLoadIdentity();
      glRotatef(rol*(mode?torq:-torq),0.,0.,1.); 
      glRotatef(ele*-torq,1.,0.,0.); 
      glRotatef(azi*-torq,0.,1.,0.);
      glMultMatrixf(starmat); 
      glGetFloatv(GL_MODELVIEW_MATRIX,starmat);
      }
   glPopMatrix();
   opaw=paw; ohx=hx; ohy=hy; ohz=hz;
             owx=wx; owy=wy; owz=wz;
   if(morph) autotymer(0);  /* advance autotymer */
   audiofunc();
}

void drawcaveinit(void){   /* kludge? needed why ? */  
   CAVEFar = 1000.;
   glClearColor(0.,0.,0.,0.);
   glClearDepth(1.);
}

void drawcave(void){
  float hx,hy,hz;
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  drawstars();
  graffiti();
  CAVEGetHead(hx,hy,hz);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glTranslatef(hx,hy,hz);
  glMultMatrixf(aff);
  glScalef(siz,siz,siz);
  drawall();
  glPopMatrix();
}
#endif

/**********************************************************************/
float speedometer(void){
double dbl; static double rate; static int ii=0;

static struct _timeb lnow, lthen;

   if(++ii % 8 == 0){  /* 8 times around measure time */

	   _ftime(&lnow);
		dbl =  (double)(lnow.time - lthen.time)
			 +(double)(lnow.millitm - lthen.millitm)/1000;
		lthen = lnow;  rate = 8/dbl;
      }

   return((float)rate);
}


void messages(void){     
 
 char buf[256]; /* console messages are done differently from cave */
#define  LABEL2(x,y,W,u) {sprintf(buf,(W),(u));char2wall(x,y,0.,buf);}
  glMatrixMode(GL_PROJECTION); glPushMatrix(); glLoadIdentity();
  gluOrtho2D(0,3000,0,3000);
  glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();
      /*bull's eye*/
      if(mode==TURNMODE) glColor3f(0x22/255.,0x88/255.,0xdd/255.);
        else      glColor3f(.8,.8,.8);
      LABEL2(1500,1500,"%s","o");
      /* writings */
      if(mode==TURNMODE) glColor3f(0.,1.,1.);
        else      glColor3f(1.,1.,0.);
      LABEL2(80,80,"%4.1f fps",speedometer());
      LABEL2(80,2840,\
      "(ESC)ape (B)inoc (MAUS2)Fore (BAR)Flymode %s (H)omotopy (W)riting",
             mode?"FLYING":"CONTROL");
      LABEL2(10,10,"SchpRel \
   by Mark Flider, UIUC,(C) 2000 %s","");
      LABEL2(80,2770,"(N)ose   %0.3f",nose);
      LABEL2(80,2700,"(V)el %1.4f percent",vel/c);  /*v/c keeps changing names */
      LABEL2(80,2630,"Lightspeed (C) %1.4f",c);
      LABEL2(80,2560,"near clipper %g", mysiz*focal);
      LABEL2(80,2490,"f(O)cal factor %g",focal);
      LABEL2(80,2420,"my s(I)ze %.2g",mysiz);
      LABEL2(80,2350,"farr cli(P)er= %.2g",farr);
      LABEL2(80,2280,"(Z)ap %s","");
   if(track) {
      LABEL2(80,2210,"(T)rack : flitrack",0);
	}
   else {
      LABEL2(80,2210,"(T)rack : chaptrack",0);
	}
   glPopMatrix();
glMatrixMode(GL_PROJECTION); glPopMatrix();
} 




float VEL(float vel1,float c1) {
        return MAX(c1*-.9999,MIN(c1*.9999,vel1));
}

float dist2(float x1, float y1, float z1) {
   return x1*x1+y1*y1+z1*z1;
}

float gamm (float v1,float c1) {
        return 1/sqrt(1-v1*v1/c1/c1);
}

float thetime (float x1, float y1, float z1, float c1) {
        return sqrt(dist2(x1,y1,z1))/c1;
}

updateTriangles(float ca,float cb,float sa,float sb,float v,float thegamma)
{
   float temp;
   for (a=0; a<16; a++) for(b=0;b<5;b++)
   {
      temp  = trib[a][b][2] * ca - sa * trib[a][b][0];
      trib[a][b][0] = trib[a][b][0] * ca + sa * trib[a][b][2];
      trib[a][b][2] = temp * cb - sb * trib[a][b][1];
      trib[a][b][1] = trib[a][b][1] * cb + sb * temp;

      if(mode==FLYMODE)    trib[a][b][2] += v;
      tribdraw[a][b][2] = thegamma*(trib[a][b][2]);
      tribdraw[a][b][2] += thegamma*v*(trib[a][b][2]*v-sqrt(trib[a][b][2]*trib[a][b][2]*v*v+(c*c-v*v)*dist2(trib[a][b][0],trib[a][b][1],trib[a][b][2])))/(c*c-v*v);
      tribdraw[a][b][0] = trib[a][b][0];
      tribdraw[a][b][1] = trib[a][b][1];
   }

   for (a=0; a<16; a++) for(b=0;b<5;b++)
   {
      temp  = trit[a][b][2] * ca - sa * trit[a][b][0];
      trit[a][b][0] = trit[a][b][0] * ca + sa * trit[a][b][2];
      trit[a][b][2] = temp * cb - sb * trit[a][b][1];
      trit[a][b][1] = trit[a][b][1] * cb + sb * temp;

      if(mode==FLYMODE)    trit[a][b][2] += v;
      tritdraw[a][b][2] = thegamma*(trit[a][b][2]);
      tritdraw[a][b][2] += thegamma*v*(trit[a][b][2]*v-sqrt(trit[a][b][2]*trit[a][b][2]*v*v+(c*c-v*v)*dist2(trit[a][b][0],trit[a][b][1],trit[a][b][2])))/(c*c-v*v); 
      tritdraw[a][b][0] = trit[a][b][0];
      tritdraw[a][b][1] = trit[a][b][1];
   }

}

updateBeams(float ca,float cb,float sa,float sb,float v,float thegamma)
{
   float temp;
   for (a=0; a<16; a++) for (b=0;b<30;b++)
   {
      temp  = beam[a][b][2] * ca - sa * beam[a][b][0];
      beam[a][b][0] = beam[a][b][0] * ca + sa * beam[a][b][2];
      beam[a][b][2] = temp * cb - sb * beam[a][b][1];
      beam[a][b][1] = beam[a][b][1] * cb + sb * temp;

      if(mode==FLYMODE)    beam[a][b][2] += v;
      beamdraw[a][b][2] = thegamma*(beam[a][b][2]);
      beamdraw[a][b][2] += thegamma*v*(beam[a][b][2]*v-sqrt(beam[a][b][2]*beam[a][b][2]*v*v+(c*c-v*v)*dist2(beam[a][b][0],beam[a][b][1],beam[a][b][2])))/(c*c-v*v);
      beamdraw[a][b][0] = beam[a][b][0];
      beamdraw[a][b][1] = beam[a][b][1];
   }

}




/* REPLACEMENT FOR CHAPTRACK - flitrack, special relativity edition */

void flitrack (int but,int xx,int yy,int shif){

#define x(asdf) flod[asdf][0]
#define y(asdf) flod[asdf][1]
#define z(asdf) flod[asdf][2]
#define zd(sdf) flodraw[sdf][2]

   long dx,dy;
   float raddi, theta, temp, ca,sa,cb,sb, v,thegamma;
   
   dx = xx -.5*xt; dx = fabs(dx)>15?dx:0;
   dy = 0;/*yy -.5*yt; dy = fabs(dy)>5?dy:0;*/

        ca = cos(torq*dx/100);
        sa = sin(torq*dx/100);
        cb = cos(torq*dy);    /* I'm gonna leave these here in case someone */
        sb = sin(torq*dy);    /* in the future wants to implement them */
 
        for (a=0; a<1001; a++)
        {
       temp  = z(a) * ca - sa * x(a);
       x(a)  = x(a) * ca + sa * z(a);
       z(a)  = temp * cb - sb * y(a);
       y(a)  = y(a) * cb + sb * temp;
        }
        for (a=0; a<11; a++) for(b=0;b<40;b++)
        {
       temp  = pillars[a][b][2] * ca - sa * pillars[a][b][0];
       pillars[a][b][0] = pillars[a][b][0] * ca + sa * pillars[a][b][2];
       pillars[a][b][2] = temp * cb - sb * pillars[a][b][1];
       pillars[a][b][1] = pillars[a][b][1] * cb + sb * temp;
        }
        for (a=0; a<1001; a++)
        {
       temp  = ceid[a][2] * ca - sa * ceid[a][0];
       ceid[a][0] = ceid[a][0] * ca + sa * ceid[a][2];
       ceid[a][2] = temp * cb - sb * ceid[a][1];
       ceid[a][1] = ceid[a][1] * cb + sb * temp;
        }	


	if(mode==FLYMODE){
      glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();
	glRotatef(dx*torq,0,1,0);
      glPushMatrix();
      glMultMatrixf(starmat);
      glGetFloatv(GL_MODELVIEW_MATRIX,starmat);
      glPopMatrix();
	glPopMatrix();
   }	

        v = VEL(vel,c);
        thegamma = gamm(v,c);
        for (a=0;a<1001;a++) { 			/* floor loop */
           if(mode==FLYMODE)   z(a) += v;
           flodraw[a][2] = thegamma*(z(a));
           flodraw[a][2] += thegamma*v*(z(a)*v-sqrt(z(a)*z(a)*v*v+(c*c-v*v)*dist2(x(a),y(a),z(a))))/(c*c-v*v); /*new version*/
	   flodraw[a][0] = x(a);
	   flodraw[a][1] = y(a);
        }

        for (a=0;a<1001;a++) {		 /* ceiling loop */
           if(mode==FLYMODE)    ceid[a][2] += v;
           ceidraw[a][2] = thegamma*ceid[a][2];
           ceidraw[a][2] += thegamma*v*(ceid[a][2]*v-sqrt(ceid[a][2]*ceid[a][2]*v*v+(c*c-v*v)*dist2(ceid[a][0],ceid[a][1],ceid[a][2])))/(c*c-v*v); /*new version*/
           ceidraw[a][0] = ceid[a][0];
           ceidraw[a][1] = ceid[a][1];
        }


      for (a=0;a<11;a++) for(b=0;b<40;b++) {	 /* pillar loop */
           if(mode==FLYMODE)    pillars[a][b][2] += v;
           pilldraw[a][b][2] = thegamma*(pillars[a][b][2]);
           pilldraw[a][b][2] += thegamma*v*(pillars[a][b][2]*v-sqrt(pillars[a][b][2]*pillars[a][b][2]*v*v+(c*c-v*v)*dist2(pillars[a][b][0],pillars[a][b][1],pillars[a][b][2])))/(c*c-v*v); /*new version*/
           pilldraw[a][b][0] = pillars[a][b][0];
           pilldraw[a][b][1] = pillars[a][b][1];
        }
	
   updateTriangles(ca,cb,sa,sb,v,thegamma);
   updateBeams(ca,cb,sa,sb,v,thegamma);

}

void chaptrack(int but,int xx,int yy,int shif){
   long dx,dy;
   dx = xx -.5*xt; dx = abs(dx)>5?dx:0;
   dy = yy -.5*yt; dy = abs(dy)>5?dy:0;

   glMatrixMode(GL_MODELVIEW); glPushMatrix(); glLoadIdentity();

   if(mode==TURNMODE) glTranslatef(aff[12],aff[13],aff[14]);
   glRotatef(dx*torq,0.,1.,0.); glRotatef(dy*torq,1.,0.,0.);
   if(but&(1<<GLUT_RIGHT_BUTTON ))glRotatef(shif?-10:-1,0.,0.,1.);
   if(but&(1<<GLUT_LEFT_BUTTON  ))glRotatef(shif?10:1,0.,0.,1.);
   if(mode==FLYMODE){
      glPushMatrix();
      glMultMatrixf(starmat);
      glGetFloatv(GL_MODELVIEW_MATRIX,starmat);
      glPopMatrix();
   }
   if(but&(1<<GLUT_MIDDLE_BUTTON)) glTranslatef(0.,0.,shif ? -speed : speed);
   if(mode==TURNMODE) glTranslatef(-aff[12],-aff[13],-aff[14]);
   glMultMatrixf(aff);
   glGetFloatv(GL_MODELVIEW_MATRIX,aff);
   {int ii,jj; for(ii=0;ii<3;ii++){ lu[ii]=0; /* calculite */
          for(jj=0;jj<3;jj++) lu[ii] += aff[ii*4+jj]*lux[jj];}}
   glPopMatrix();
}


void reshaped(int xx, int yy){xt=xx ; yt=yy;}   /* what is this for ? */

void drawcons(void){  
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  if(binoc) glViewport(0,yt/4,xt/2,yt/2);
  glMatrixMode(GL_PROJECTION); glLoadIdentity();
  glFrustum(-mysiz*xt/yt,mysiz*xt/yt,-mysiz,mysiz,mysiz*focal,farr); 
  glMatrixMode(GL_MODELVIEW); glLoadIdentity();
  drawstars();
  glTranslatef(-binoc*nose,0.0,0.0);
  glMultMatrixf(aff);
  drawall();
  if(binoc){
    glViewport(xt/2,yt/4,xt/2,yt/2); 
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    drawstars();
    glTranslatef(binoc*nose,0.0,0.0);
    glMultMatrixf(aff);
    drawall();
    }
  glViewport(0,0,xt,yt);
  if(msg) messages();
  glutSwapBuffers();
}

void idle(void){ /*do this when nothing else is happening*/
   if(morph) autotymer(0);  /* advance autotymer */ 
   glutPostRedisplay();  /*redraw the window*/

   if(track) flitrack(BUT,XX,YY,SHIF);
   else chaptrack(BUT,XX,YY,SHIF);

   audiofunc();  
}

void mousepushed(int but,int stat,int x,int y){
  if(stat==GLUT_DOWN) BUT |= (1<<but);
  else BUT &= (-1 ^ (1<<but));  
  XX=x; YY=y; SHIF=(glutGetModifiers()==GLUT_ACTIVE_SHIFT)?1:0;
}

void mousemoved(int x,int y){  XX=x; YY=y; }

void caveframe(void){
#if CAVE
  if(track==GALILEAN)cavetrack();
  if(track==RELATIVE)flicavetrack();
#endif
}

int  main(int argc, char **argv){  
   arguments(argc,argv); 
   if(caveyes)
#ifdef CAVE
       CAVEConfigure(&argc, argv, NULL)
#endif
       ;
   getmem();
   dataprep();
 
   if(caveyes){
#ifdef CAVE
       CAVEInit(); /* Each wall is (part of) a forked process from here on.*/ 
       CAVEFrameFunction(caveframe,0);
       /*is restricted to MasterWall, so once per frame */
       CAVEInitApplication(drawcaveinit, 0); 
       CAVEDisplay(drawcave, 0);
       while(!CAVEgetbutton(CAVE_ESCKEY))
         {
         cavekeybo();  /* is asynchronous from display processes */ 
	 }
       audioclean();
       CAVEExit();
#endif
       ;}
     else{ /*console main*/
       glutInit(&argc, argv);
       glutInitDisplayMode(GLUT_DOUBLE|GLUT_DEPTH);
       switch(win)
         { case 0: break;
           case 1: glutInitWindowSize(640, 480);
                   glutInitWindowPosition(0,1024-480);
                   break;
           case 2: glutInitWindowPosition(0,0);
	           break;
         }
       glutCreateWindow("<* SchpRel in C/OpenGL/GLUT *>");
       if(win==2) glutFullScreen();
       glEnable(GL_DEPTH_TEST);
       glutDisplayFunc(drawcons);       

       glutKeyboardFunc(keyboard);
       /* glutKeyboardUpFunc(keyboardUp); */
       glutSpecialFunc(special_keybo);
       glutMouseFunc(mousepushed);
       glutMotionFunc(mousemoved);       
       glutPassiveMotionFunc(mousemoved); 
       glutReshapeFunc(reshaped);
       glutIdleFunc(idle);             
       glutMainLoop();
       }
} 
